import * as O from "fp-ts/Option";
import * as E from "fp-ts/Either";
import { flow, identity, pipe } from "fp-ts/function";
import { construct, isInstanceOf } from "./Function.js";
export const clone = u => unsafeParse(u.href);
export const unsafeParse = (x) => pipe([x], construct(URL));
export const parse = (f) => (x) => E.tryCatch(() => unsafeParse(x), e => f(e));
export const parseO = flow(parse(identity), O.fromEither);
export const isURL = isInstanceOf(URL);
